/*
 * Copyright (C) 2007 Moritz Orbach <web@apfelboymchen.homeunix.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * disclaimer:
 * I guess this isn't the best code. I just wrote the functions without 
 * thinking much about them after it started to work. So there may be the the 
 * one or other segfault lurking.
 *
 */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include "state.h"

#define SLOTS 10

t_config cfg[SLOTS];
t_config current_cfg;
int slots[SLOTS] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };


typedef struct {
	char *key;
	char *value;
} t_option;

/*
 * **config -> *var_from_call -> something
 * xy = somethingnew
 *
 * *config = &xy    ==    var_from_call = &xy
 * *var_from_call -> somethingnew
 *
 */
int loadslot(t_config **config, int slot)
{
	if (!slots[slot]) {
		return 0;
	}
	current_cfg = cfg[slot];
	*config = &current_cfg;
	return 1;

}

void rstrip(char *s, char after)
{
	int i = strlen(s);
	i--;

	while (i > 0 && s[i] == after) {
		s[i] = '\0';
		i--;
	}
}

/* strip *s after *after */
int strip(char *s, char *after)
{
	char *substring;

	/* printf("\n--- suchen: %s ----\n", after); */
	substring = strstr(s, after);

	if (substring) {
		/* printf("weg mit >%s<!\n", substring); */
		substring[0] = '\0';
		return 1;
	} else {
		/* printf(">%s< nicht gefunden\n", after); */
		return 0;
	}

}

/*
 * TODO: auch mal richtig drueber nachdenken, ob das mit den laengen 
 * funktioniert
 */
void strip_whitespace(char *s)
{
	int i = 0;
	int l = strlen(s);

	rstrip(s, 32);
	rstrip(s, 9);
	while (s[i] != '\0') {
		if (s[i] == ' ' && i < l) {
			/* move remaining string to the left */
			void *dst = &s[i];
			void *src = &s[i+1];
			memmove(dst, src, l-1);
			s[l-1] = '\0';
		}
		i++;
	}
}

/*
 * splits string *s into key and value
 */
int get_option(t_option *option, char *s)
{
	int len;
	char *p;

	len = strlen(s);
	p = strstr(s, "=");

	/* todo ob das stimmt mit der laenge */
	if (p && strlen(p) < len) {
		/* option begins at the start of the string */
		option->key = s;
		/* deletes '=' */
		p[0] = '\0';
		/* value is after '=' */
		option->value = p + 1;

		/* eigentlich ignorieren die convert-funktionen whitespace */
		strip_whitespace(option->key);
		strip_whitespace(option->value);
		return 1;
	} else {
		return 0;
	}
}

/*
 * string to int
 * returns
 *   0 if string is no number
 *   1 success
 */
int s2int(char *str, int *number)
{
	char *endptr;

	*number = strtol(str, &endptr, 10);
	if (str == '\0' || *endptr != '\0')
		return 0;

	return 1;
}

int s2uint(char *str, unsigned int *number)
{
	char *endptr;

	errno = 0;
	*number = strtol(str, &endptr, 10);
	if (errno)
		perror("s2uint");

	if (str == NULL || *endptr != '\0')
		return 0;

	return 1;
}

/*
 * string to double
 * returns
 *   0 if string is no number
 *   1 success
 */
int s2double(char *str, double *number)
{
	char *endptr;

	errno = 0;
	*number = strtod(str, &endptr);
	if (errno)
		perror(endptr);

	if (str == '\0' || *endptr != '\0')
		return 0;

	return 1;
}

int set_option(t_option option, t_config *cfg)
{
	/*
	printf("key  : >%s<\n", option.key);
	printf("value: >%s<\n", option.value);
	*/
	if (!strcmp("y_amplitude", option.key)) {
		if (s2uint(option.value, &cfg->y_amplitude)) {
			return 1;
		}
	}
	if (!strcmp("x_amplitude", option.key)) {
		if (s2uint(option.value, &cfg->x_amplitude)) {
			return 1;
		}
	}
	if (!strcmp("y_frequency", option.key)) {
		if (s2double(option.value, &cfg->y_frequency)) {
			return 1;
		}
	}
	if (!strcmp("x_frequency", option.key)) {
		if (s2double(option.value, &cfg->x_frequency)) {
			return 1;
		}
	}
	if (!strcmp("y_speed", option.key)) {
		if (s2double(option.value, &cfg->y_speed)) {
			return 1;
		}
	}
	if (!strcmp("x_speed", option.key)) {
		if (s2double(option.value, &cfg->x_speed)) {
			return 1;
		}
	}
	if (!strcmp("slope", option.key)) {
		if (s2int(option.value, &cfg->slope)) {
			return 1;
		}
	}
	if (!strcmp("spacing", option.key)) {
		if (s2uint(option.value, &cfg->spacing)) {
			return 1;
		}
	}
	if (!strcmp("color", option.key)) {
		if (s2uint(option.value, &cfg->color)) {
			return 1;
		}
	}
	if (!strcmp("flag_width", option.key)) {
		if (s2uint(option.value, &cfg->flag_width)) {
			return 1;
		}
	}
	if (!strcmp("border_top", option.key)) {
		if (s2int(option.value, &cfg->border_top)) {
			return 1;
		}
	}
	if (!strcmp("border_left", option.key)) {
		if (s2int(option.value, &cfg->border_left)) {
			return 1;
		}
	}
	if (!strcmp("border_left", option.key)) {
		if (s2int(option.value, &cfg->border_left)) {
			return 1;
		}
	}
	if (!strcmp("flag_height", option.key)) {
		if (s2uint(option.value, &cfg->flag_height)) {
			return 1;
		}
	}
	return 0;
}

int load_config()
{
	FILE *fp;
	char line[MAXLINELENGTH];
	t_option option;
	int slot;

	fp = fopen(CFGFILE, "r");
	if (fp == NULL) {
		perror(CFGFILE);
		return 0;
	}

	while (fgets (line, MAXLINELENGTH - 1, fp)) {
		/* printf("\n%s", line); */

		strip(line, "#");
		strip(line, "\n");
		/* strip(line, '\n'); */
		if (line[0] == '\0') {
			continue;
		}

		/*
		*/
		if (line[0] == '[') {
			s2int(&line[1], &slot);
			slots[slot] = 1;
			/* printf("slot: %d\n",slots[slot]); */
		}
		
		if (get_option(&option, line)) {
			/* printf(">%s< = >%s<\n", option.key, option.value); */
			set_option(option, &cfg[slot]);
			/*
			*/
		}
	}
	return 1;
}

int save(int slot)
{
	FILE *fp;

	printf("saving to slot %d\n", slot);

	cfg[slot] = current_cfg;
	slots[slot] = 1;

	fp = fopen(CFGFILE, "w");
	if (fp == NULL) {
		perror(CFGFILE);
		return 1;
	}
	fprintf(fp, "%s\n\n", "# you may edit this file, but all comments you make will be lost");

	for (slot = 0; slot < SLOTS; slot++) {
		if (slots[slot]) {
			fprintf(fp, "[%d]\n", slot);
			fprintf(fp, "y_amplitude = %d\n", cfg[slot].y_amplitude);
			fprintf(fp, "x_amplitude = %d\n", cfg[slot].x_amplitude);
			fprintf(fp, "y_frequency = %f\n", cfg[slot].y_frequency);
			fprintf(fp, "x_frequency = %f\n", cfg[slot].x_frequency);
			fprintf(fp, "y_speed     = %f\n", cfg[slot].y_speed);
			fprintf(fp, "x_speed     = %f\n", cfg[slot].x_speed);
			fprintf(fp, "slope       = %d\n", cfg[slot].slope);
			fprintf(fp, "spacing     = %d\n", cfg[slot].spacing);
			fprintf(fp, "color       = %d\n", cfg[slot].color);
			fprintf(fp, "flag_width  = %d\n", cfg[slot].flag_width);
			fprintf(fp, "border_top  = %d\n", cfg[slot].border_top);
			fprintf(fp, "border_left = %d\n", cfg[slot].border_left);
			fprintf(fp, "flag_height = %d\n\n", cfg[slot].flag_height);
		}
	}
	fprintf(fp, "%s\n\n", "# vim:ft=cfg");
	fclose(fp);
	return 0;
}

/*
 * vim:ft=c
 */
